package book_test

import (
	"context"
	"database/sql"
	"encoding/json"
	"fmt"
	"github.com/golang/mock/gomock"
	"github.com/golang/protobuf/ptypes"
	"go.appointy.com/book"
	"google.golang.org/genproto/protobuf/field_mask"
	"io/ioutil"
	"log"
	"os"
	"strings"
	"testing"
	. "github.com/smartystreets/goconvey/convey"
	bookpb "go.appointy.com/book/pb"
	authorpb "go.appointy.com/book/pb/author"
	mocks "go.appointy.com/book/mocks"
	"go.appointy.com/chaku/driver"
)

func TestBook_BDD(t *testing.T) {

	ctx := context.Background()
	ctrl, srv, sMock := getMocks(t)
	defer ctrl.Finish()

	Convey("Create Book", t, func() {

		b := getBookObject()
		bk := &b
		bookID := ""

		sMock.EXPECT().GetAuthor(gomock.Any(), &authorpb.GetAuthorRequest{Id: bk.Author.Id}).Return(&authorpb.Author{}, nil).Times(1)

		createBk, err := srv.CreateBook(ctx, &bookpb.CreateBookRequest{Book: bk})

		So(err, ShouldEqual, nil)

		ids := strings.Split(createBk.Id, "/")
		bookID = ids[len(ids)-1]
		bk.Id = createBk.Id

		Convey("Get Book", func() {

			gotBk, err := srv.GetBook(ctx, &bookpb.GetBookRequest{Id: bookID})

			// generated by store
			bk.Author.Id = gotBk.Author.Id

			So(err, ShouldEqual, nil)
			So(gotBk, ShouldResemble, bk)
		})

		Convey("Update Book Flow", func() {

			bk.Title = "Updated Title"

			sMock.EXPECT().GetAuthor(gomock.Any(), gomock.Any()).Return(&authorpb.Author{}, nil).Times(1)

			_, err := srv.UpdateBook(ctx, &bookpb.UpdateBookRequest{Book: bk, UpdateMask: &field_mask.FieldMask{Paths: []string{"title"}}})

			So(err, ShouldEqual, nil)

			Convey("Get Book", func() {

				gotUBk, err := srv.GetBook(ctx, &bookpb.GetBookRequest{Id: bookID})
				bk.Author.Id = gotUBk.Author.Id

				So(err, ShouldEqual, nil)
				So(gotUBk, ShouldResemble, bk)
			})
		})

		Convey("Delete Book Flow", func() {

			_, err := srv.DeleteBook(ctx, &bookpb.DeleteBookRequest{Id: bookID})

			So(err, ShouldEqual, nil)

			Convey("Get Book", func() {

				_, err := srv.GetBook(ctx, &bookpb.GetBookRequest{Id: bookID})

				So(err, ShouldNotEqual, nil)

			})
		})

		Convey("List Book Flow", func() {

			_, err := srv.ListBook(ctx, &bookpb.ListBookRequest{})

			So(err, ShouldEqual, nil)

		})
	})
}

func getMocks(t *testing.T) (*gomock.Controller, bookpb.BooksServer, *mocks.MockAuthorsClient) {

	ctrl := gomock.NewController(t)

	mockASC := mocks.NewMockAuthorsClient(ctrl)

	srv := book.NewBooksServer(createStore(), mockASC)

	return ctrl, srv, mockASC
}

func createStore() bookpb.BookStore {
	config := getConfig()

	db, err := sql.Open("postgres", config)
	if err != nil {
		panic(fmt.Errorf("connection not open | %v", err.Error()))
	}
	if err = db.Ping(); err != nil {
		panic("ping  " + err.Error())
	}
	return bookpb.NewPostgresBookStore(db, driver.GetUserName)
}

func getConfig() string {
	config := "host=localhost port=5432 user=postgres password=password dbname=chaku sslmode=disable"

	// create pgconfig.json and put your credentials in it
	pg, err := os.Open("pgconfig.json")
	if err == nil {
		pgc, err := ioutil.ReadAll(pg)
		if err != nil {
			log.Println(err)
		}

		mp := make(map[string]string, 0)
		err = json.Unmarshal(pgc, &mp)
		if err != nil {
			log.Fatalln(err)
		}
		config = fmt.Sprintf("host=%s port=%s user=%s password=%s dbname=%s sslmode=disable",
			mp["host"], mp["port"], mp["user"], mp["password"], mp["dbname"])
	}
	return config
}

func getBookObject() bookpb.Book {

	return bookpb.Book{
		Id: "dummy", // generated by store
		Title: "The Demo Book",
		Author: &bookpb.Author{
			Id: "aut_12345",
			Name: "Author Name",
			Email: "some@email.com",
		},
		Rating: 4,
		Genre: bookpb.Genre_FICTION,
		PublishDate: ptypes.TimestampNow(),
	}
}



